| OpenCV 3.4.3 Open Source Computer Vision

Public Member Functions | List of all members
cv::ximgproc::SuperpixelSEEDS Class Referenceabstract
Extended Image Processing » Superpixels

Class implementing the SEEDS (Superpixels Extracted via Energy-Driven Sampling) superpixels algorithm described in [195] . More...

`#include "seeds.hpp"`

Inheritance diagram for cv::ximgproc::SuperpixelSEEDS:

## Public Member Functions
virtual | ~SuperpixelSEEDS ()
virtual void | getLabelContourMask (OutputArray image, bool thick_line=false)=0
| Returns the mask of the superpixel segmentation stored in SuperpixelSEEDS object. More...
virtual void | getLabels (OutputArray labels_out)=0
| Returns the segmentation labeling of the image. More...
virtual int | getNumberOfSuperpixels ()=0
| Calculates the superpixel segmentation on a given image stored in SuperpixelSEEDS object. More...
virtual void | iterate (InputArray img, int num_iterations=4)=0
| Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelSEEDS object. More...
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Additional Inherited Members
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class implementing the SEEDS (Superpixels Extracted via Energy-Driven Sampling) superpixels algorithm described in [195] .

The algorithm uses an efficient hill-climbing algorithm to optimize the superpixels' energy function that is based on color histograms and a boundary term, which is optional. The energy function encourages superpixels to be of the same color, and if the boundary term is activated, the superpixels have smooth boundaries and are of similar shape. In practice it starts from a regular grid of superpixels and moves the pixels or blocks of pixels at the boundaries to refine the solution. The algorithm runs in real-time using a single CPU.

## Constructor & Destructor Documentation

## § ~SuperpixelSEEDS()

virtual cv::ximgproc::SuperpixelSEEDS::~SuperpixelSEEDS | ( |  | ) |
| inline virtual

## Member Function Documentation

## § getLabelContourMask()

virtual void cv::ximgproc::SuperpixelSEEDS::getLabelContourMask | ( | OutputArray | image,
|  | bool | thick_line = `false`
| ) |  |
| pure virtual

Python:
| image | = | cv.ximgproc_SuperpixelSEEDS.getLabelContourMask( | [, image[, thick_line]] | )

Returns the mask of the superpixel segmentation stored in SuperpixelSEEDS object.

Parameters

  image | Return: CV_8UC1 image mask where -1 indicates that the pixel is a superpixel border, and 0 otherwise.
  thick_line | If false, the border is only one pixel wide, otherwise all pixels at the border are masked.

The function return the boundaries of the superpixel segmentation.

Note
  - (Python) A demo on how to generate superpixels in images from the webcam can be found at opencv_source_code/samples/python2/seeds.py
    - (cpp) A demo on how to generate superpixels in images from the webcam can be found at opencv_source_code/modules/ximgproc/samples/seeds.cpp. By adding a file image as a command line argument, the static image will be used instead of the webcam.
    - It will show a window with the video from the webcam with the superpixel boundaries marked in red (see below). Use Space to switch between different output modes. At the top of the window there are 4 sliders, from which the user can change on-the-fly the number of superpixels, the number of block levels, the strength of the boundary prior term to modify the shape, and the number of iterations at pixel level. This is useful to play with the parameters and set them to the user convenience. In the console the frame-rate of the algorithm is indicated.

image

## § getLabels()

virtual void cv::ximgproc::SuperpixelSEEDS::getLabels | ( | OutputArray | labels_out | ) |
| pure virtual

Python:
| labels_out | = | cv.ximgproc_SuperpixelSEEDS.getLabels( | [, labels_out] | )

Returns the segmentation labeling of the image.

Each label represents a superpixel, and each pixel is assigned to one superpixel label.

Parameters

  labels_out | Return: A CV_32UC1 integer array containing the labels of the superpixel segmentation. The labels are in the range [0, getNumberOfSuperpixels()].

The function returns an image with ssthe labels of the superpixel segmentation. The labels are in the range [0, getNumberOfSuperpixels()].

## § getNumberOfSuperpixels()

virtual int cv::ximgproc::SuperpixelSEEDS::getNumberOfSuperpixels | ( |  | ) |
| pure virtual

Python:
| retval | = | cv.ximgproc_SuperpixelSEEDS.getNumberOfSuperpixels( |  | )

Calculates the superpixel segmentation on a given image stored in SuperpixelSEEDS object.

The function computes the superpixels segmentation of an image with the parameters initialized with the function createSuperpixelSEEDS().

## § iterate()

virtual void cv::ximgproc::SuperpixelSEEDS::iterate | ( | InputArray | img,
|  | int | num_iterations = `4`
| ) |  |
| pure virtual

Python:
| None | = | cv.ximgproc_SuperpixelSEEDS.iterate( | img[, num_iterations] | )

Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelSEEDS object.

This function can be called again for other images without the need of initializing the algorithm with createSuperpixelSEEDS(). This save the computational cost of allocating memory for all the structures of the algorithm.

Parameters

  img | Input image. Supported formats: CV_8U, CV_16U, CV_32F. Image size & number of channels must match with the initialized image size & channels with the function createSuperpixelSEEDS(). It should be in HSV or Lab color space. Lab is a bit better, but also slower.
  num_iterations | Number of pixel level iterations. Higher number improves the result.

The function computes the superpixels segmentation of an image with the parameters initialized with the function createSuperpixelSEEDS(). The algorithms starts from a grid of superpixels and then refines the boundaries by proposing updates of blocks of pixels that lie at the boundaries from large to smaller size, finalizing with proposing pixel updates. An illustrative example can be seen below.

image

The documentation for this class was generated from the following file:

- /build/3_4-contrib_docs-lin64/opencv_contrib/modules/ximgproc/include/opencv2/ximgproc/seeds.hpp